;#######################################################################################################################
; ws_ex_composited  (v.2006-09-30)
;#######################################################################################################################

.386
.model flat,stdcall
option casemap:none

include    \masm32\include\windows.inc
include    \masm32\include\user32.inc
include    \masm32\include\kernel32.inc
include    \masm32\include\gdi32.inc
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\gdi32.lib

.data
DlgName  db "Dlg",0
ALPHA    dd 200
COLORKEY dd 0
about    db "by kero <geocities.com/xmemor>",0

.data?
hinst   HINSTANCE ?
hw_gb   HWND ?
hbrush  HBRUSH ?

.code

;#######################################################################################################################

SubProc proc uses ebx hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	local rt:RECT
	local pt:POINT


	.if (uMsg==WM_SETTEXT || uMsg==WM_KEYDOWN || uMsg==WM_CHAR || uMsg==WM_LBUTTONDBLCLK  || uMsg==WM_KILLFOCUS)
		invoke GetWindowLong,hWnd,GWL_USERDATA
		invoke CallWindowProc,eax,hWnd,uMsg,wParam,lParam
		.if uMsg!=WM_KILLFOCUS
			invoke SetFocus,hWnd
		.endif
		jmp @f

	.elseif uMsg==WM_MOVE ; uMsg==WM_WINDOWPOSCHANGING
@@:
		invoke SetWindowPos,hWnd,0,0,0,0,0,SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED OR SWP_NOSENDCHANGING

	.elseif uMsg==WM_LBUTTONDOWN || uMsg==WM_LBUTTONUP || uMsg==WM_LBUTTONDBLCLK
		mov eax,hWnd
		cmp eax,hw_gb
		jnz @f
		invoke GetWindowRect,hWnd,addr rt
		invoke GetAncestor,hWnd,GA_PARENT
		mov ebx,eax
		invoke MapWindowPoints,0,ebx,addr rt,2
		mov eax,lParam
		mov ecx,eax
		and eax,0ffffh
		shr ecx,16
		mov pt.x,eax
		mov pt.y,ecx
		invoke PtInRect,addr rt,pt.x,pt.y
		.if eax!=0
			invoke MapWindowPoints,ebx,hWnd,addr pt,1
			mov eax,pt.y
			shl eax,16
			add eax,pt.x
			mov lParam,eax
			.if uMsg==WM_LBUTTONDOWN
				invoke DefWindowProc,hWnd,WM_NCLBUTTONDOWN,HTCAPTION,lParam
			.endif
		.endif

	.else
@@:
		invoke GetWindowLong,hWnd,GWL_USERDATA
		invoke CallWindowProc,eax,hWnd,uMsg,wParam,lParam
		ret
	.endif
	xor eax,eax
	ret
SubProc endp

;#######################################################################################################################

SubClass proc uses ebx hWnd:HWND,id:DWORD
	invoke GetDlgItem,hWnd,id
	mov ebx,eax
	invoke SetWindowLong,ebx,GWL_WNDPROC,addr SubProc
	invoke SetWindowLong,ebx,GWL_USERDATA,eax
	mov eax,ebx
	ret
SubClass endp

;#######################################################################################################################

SetBg proc uses ebx hWnd:HWND
	local rt:RECT

	invoke DeleteObject,hbrush
	invoke GetClientRect,hWnd,addr rt
	invoke LoadImage,hinst,600,IMAGE_BITMAP,rt.right,rt.bottom,LR_DEFAULTCOLOR
	mov ebx,eax
	invoke CreatePatternBrush,eax
	mov hbrush,eax
	invoke DeleteObject,ebx
	invoke InvalidateRect,hWnd,0,1
	ret
SetBg endp

;#######################################################################################################################

DlgProc proc uses ebx hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	local buf[MAX_PATH+1]:BYTE
	local rt:RECT
	local pt:POINT

	.if uMsg==WM_CLOSE
		invoke DeleteObject,hbrush
		invoke EndDialog,hWnd,0		

	.elseif uMsg==WM_INITDIALOG
		invoke SubClass,hWnd,2000
		mov hw_gb,eax
		invoke SubClass,hWnd,2005

		invoke SetBg,hWnd

	.elseif uMsg==WM_LBUTTONDOWN || uMsg==WM_LBUTTONUP || uMsg==WM_LBUTTONDBLCLK
		invoke SendMessage,hw_gb,uMsg,wParam,lParam
		.if uMsg==WM_LBUTTONDOWN
			invoke DefWindowProc,hWnd,WM_NCLBUTTONDOWN,HTCAPTION,lParam
		.else
			xor eax,eax
			ret
		.endif

	.elseif uMsg==WM_CTLCOLORDLG
		mov eax,hbrush
		ret

	.elseif uMsg==WM_CTLCOLORSTATIC ;&& lParam==2000
		invoke SetBkMode,wParam,TRANSPARENT
		invoke SetTextColor,wParam,0ffffffh
		invoke GetStockObject,NULL_BRUSH
		ret

	.elseif uMsg==WM_CTLCOLOREDIT
		invoke SetBkMode,wParam,TRANSPARENT
;		invoke SetBkColor,wParam,0
		invoke SetTextColor,wParam,0ffffffh
		invoke GetStockObject,NULL_BRUSH
		ret

	.elseif uMsg==WM_COMMAND
		invoke GetWindowLong,hWnd,GWL_EXSTYLE
		mov ebx,eax
		invoke GetClassLong,hWnd,GCL_STYLE
		mov ecx,eax
		.if wParam==2001
			mov edx,CS_HREDRAW
			jmp @f
		.elseif  wParam==2002
			mov edx,CS_VREDRAW
@@:
			or ecx,edx
			test eax,edx
			jz @f
			not edx
			and ecx,edx
@@:
			invoke SetClassLong,hWnd,GCL_STYLE,ecx
		.elseif wParam==2003
			mov edx,WS_EX_COMPOSITED
			mov ecx,ebx
			or ecx,edx
			test ebx,edx
			jz @f
			not edx
			and ecx,edx
@@:
			invoke SetWindowLong,hWnd,GWL_EXSTYLE,ecx
			invoke SetWindowPos,hWnd,0,0,0,0,0,SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED
		.elseif wParam==2004
			mov edx,WS_EX_LAYERED
			mov ecx,ebx
			or ecx,edx
			test ebx,edx
			jz @f
			not edx
			and ecx,edx
@@:
			invoke SetWindowLong,hWnd,GWL_EXSTYLE,ecx
			invoke SetWindowPos,hWnd,0,0,0,0,0,SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED
			invoke SetLayeredWindowAttributes,hWnd,COLORKEY,ALPHA,LWA_ALPHA or LWA_COLORKEY
		.endif

	.else
		xor eax,eax
		ret
	.endif
	xor eax,eax
	inc eax
	ret
DlgProc endp

;#######################################################################################################################

start:
	invoke GetModuleHandle,0
	mov hinst,eax
	invoke DialogBoxParam,eax,offset DlgName,0,offset DlgProc,0
	invoke ExitProcess,eax
end start

;#######################################################################################################################
